' FileName: LogTrim.Bas
' Date: 7/3/2014
' Author: Ben Ritchey
' Description: Trim text based log files
' Syntax: LOGTRIM <file> [bytes]
'           where: bytes > 4MB (default)

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

LOCAL MONTHTAB() AS STRING
LOCAL EOTIMEOUT AS DOUBLE
LOCAL ETO AS DOUBLE
LOCAL FName, PNAME AS STRING
LOCAL A AS STRING
LOCAL C, B AS LONG
LOCAL FSNow, FDiff, FCum, FSize AS QUAD
LOCAL Z AS STRING
LOCAL AA, AB AS INTEGER
LOCAL L AS INTEGER
LOCAL AC AS STRING
LOCAL CX, CY AS INTEGER
Local PgmVer as String

' Do NOT change format of next line except x-x !!!
  PgmVer=" LogTrim v1.0.E "

  CLS: ON ERROR GOTO INTERROR

COLOR 3: PRINT PgmVer;" {c} 2018  Ben Ritchey "

FName=command$: FSize=4194304: FSNow=0: FDiff=0: FCum=0

B=instr(command$," ")
if B>0 then
  FName=mid$(command$,1,B-1)
  C=val(mid$(command$,B+1))
  if C>FSize then FSize=C
end if

  if isfile(FName)=0 then
    Z="  Error: File "+FName+" not found, press any key ..."
    beep: color 4: gosub Prompt
    goto Finished
  end if

print: Z="Trimming "+FName+" to "+using$("#,###,###,###,###",FSize)+" bytes."
color 7
gosub Message
color 3

on error resume next
open FName for input as #1
if Err=70 then
  Z="  Error: File "+FName+" Permission Denied."
  beep: color 4: gosub Message
  goto Finished
end if
on error goto interror

FSNow=lof(1)
If FSNow<=FSize then goto Finished
FDiff=FSNow-FSize

open "$$TEMP$$.LOG" for output as #2

' Skip part to be truncated
while not eof(1) and FCum<FDiff
  line input#1,A: FCum=FCum+len(A)+2
wend  

' Save last line read
print #2,A

' Copy remainder of file 
while not eof(1)
  line input#1,A: print #2,A
wend

close

'backup FName
shell "cmd /c move "+Fname+" "+FName+".BKP"
shell "cmd /c move $$TEMP$$.LOG "+FName

REM  ERROR(123)
  GOTO FINISHED

Prompt:
  PRINT Z: COLOR 15: INPUT A
  COLOR 3
 RETURN

Message:
  PRINT Z
 RETURN

DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A
  END IF
  LOCATE 2,67: PRINT Z;
  LOCATE CY,CX
 RETURN

INTERROR:
  AB=ERL: AC=ERROR$(ERR): AA=ERRCLEAR

10000 PRINT

  BEEP
  COLOR 14
  PRINT "  Internal Error: ";
  COLOR 3: PRINT "Line";
  COLOR 15: PRINT AB;: COLOR 3: PRINT "  Code";
  COLOR 15: PRINT AA;: COLOR 3: PRINT " = ";
  COLOR 15: PRINT AC
  COLOR 3: PRINT "  Press any key ...";

  A="": WHILE A="": if instat then A=INKEY$ else sleep 50
   WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  BEEP
  PRINT "Ok {any key}": A=""
  WHILE A="": if instat then A=INKEY$ else sleep 50: WEND
' *** Debug

Finished:
55000 COLOR 7: PRINT
  CLOSE
'  SHELL "CLS"
EXITOR:

REM Month Table Data
DATA January, February, March, April, May, June
DATA July, August, September, October, November, December

END FUNCTION

' End of LogTrim.Bas
